/*
 * Copyright (c) 2002 David Wentzlaff
 *
 * Permission  is hereby  granted,  free  of  charge, to  any  person
 * obtaining a  copy of  this software  and  associated documentation
 * files   (the  "Software"),  to   deal  in  the   Software  without
 * restriction, including without  limitation the rights to use, copy,
 * modify, merge, publish,  distribute, sublicense, and/or sell copies
 * of  the Software,  and to  permit persons to  whom the  Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above  copyright notice  and this  permission notice  shall be
 * included in all copies or substantial portions of the Software.
 *
 * THE  SOFTWARE IS  PROVIDED "AS IS",  WITHOUT WARRANTY OF  ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING  BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY,   FITNESS   FOR   A   PARTICULAR    PURPOSE    AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
 * BE LIABLE FOR ANY CLAIM,  DAMAGES OR OTHER LIABILITY, WHETHER IN AN
 * ACTION OF  CONTRACT, TORT OR OTHERWISE, ARISING FROM,  OUT OF OR IN
 * CONNECTION  WITH THE SOFTWARE OR  THE USE OR OTHER  DEALINGS IN THE
 * SOFTWARE.  
 */

#include <stdio.h>
#include <stdlib.h>
#include "testbench.h"
#include "calc.h"

int main (int argc, char **argv)
{
	int numberOfBits;

	unsigned long howManyCycles;
	int numberOfCycles;
	if(argc == 5)
	{
		calcSetup();
		numberOfBits = atoi(argv[4]);
		howManyCycles = runTestbench(numberOfBits, argv[1], argv[2], argv[3]);
		numberOfCycles = ((howManyCycles/(numberOfBits))+1);
		printf("%d, %ld, %d\n", numberOfBits, (long) howManyCycles, numberOfCycles);
	}
	else
	{
		printf("Usage: input_name output_0_name output_1_name number_of_bits\n");
		return -1;
	}
}

