/* tomcatv.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static integer c__9 = 9;
static integer c__1 = 1;
static integer c__3 = 3;
static integer c__5 = 5;

/* C   tomcatv.f	1.5     (GENIAS)     7/26/91 */
/* C   tomcatv.f	1.6     (SNI)       10/05/94 */
/* CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC */
/* C                                                                    CC */
/* C                          T O M C A T V                             CC */
/* C                                                                    CC */
/* C     MESHGENERATION WITH THOMPSON SOLVER,  VECTORIZED VERSION       CC */
/* C                                                                    CC */
/* C      SET  N = 65, 129, 257      DO  SCALAR AND VECTOR  RUNS        CC */
/* C                                                                    CC */
/* Description of the equations and the finite difference approximation C */
/* C                               in                                   CC */
/* C W.Gentzsch, K.Neves and H.Yoshihara: Computational Fluid Dynamics: CC */
/* C  Algorithms and Supercomputers. AGARDograph No. 311, August 1987   CC */
/* C                                                                    CC */
/* C Authors:                                                           CC */
/* C       W.GENTZSCH FH REGENSBURG  AND  GENIAS SOFTWARE GmbH          CC */
/* C           Erzgebirgstr. 2, 8402 Neutraubling, Germany              CC */
/* C                                                                    CC */
/* C                     Formal modifications by                        CC */
/* C       F.FERSTL GENIAS SOFTWARE GMBH                                CC */
/* C           Erzgebirgstr. 2, 8402 Neutraubling, Germany              CC */
/* C                                                                    CC */
/* C                                                                    CC */
/* C	Adapted for PAR93 and SPEC                                    CC */
/* C	By Bodo Parady                                                CC */
/* C	November 93                                                   CC */
/* C                                                                    CC */
/* C      Adapted for SPEC CFP9                                         CC */
/* C      By Reinhold Weicker                                           CC */
/* C      Oct. 1994                                                     CC */
/* C                                                                    CC */
/* CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC */
/*                                                                      C */
/* Main program */ int main()
{
    /* Format strings */
    static char fmt_600[] = "(d20.14,d20.14)";
    static char fmt_1100[] = "(///,\002     2-D ITERATION BEHAVIOR\002)";
    static char fmt_1200[] = "(/,\002   IT    X-RES      Y-RES\002,/)";
    static char fmt_1300[] = "(1x,i4,e11.4,e11.4)";

    /* System generated locals */
    integer i__1, i__2, i__3;
    doublereal d__1, d__2, d__3;
    olist o__1;

    /* Builtin functions */
    integer f_open(), s_wsle(), do_lio(), e_wsle();
    /* Subroutine */ int s_stop();
    integer s_rsle(), e_rsle(), s_rsfe(), do_fio(), e_rsfe(), s_wsfe(), 
	    e_wsfe();

    /* Local variables */
    static integer iter;
    static doublereal a, b, c__, d__[263169]	/* was [513][513] */;
    static integer i__, j, n;
    static doublereal r__, alpha, x[263169]	/* was [513][513] */, y[
	    263169]	/* was [513][513] */;
    static integer itact;
    static doublereal aa[263169]	/* was [513][513] */, dd[263169]	
	    /* was [513][513] */, rx[263169]	/* was [513][513] */, ry[
	    263169]	/* was [513][513] */, xx, xy, yx, yy, dhi, abx, aby, 
	    dlo, rxm[1000], rym[1000], pxx, qxx, pyy, qyy, pxy, qxy;

    /* Fortran I/O blocks */
    static cilist io___1 = { 0, 6, 0, 0, 0 };
    static cilist io___2 = { 0, 5, 0, 0, 0 };
    static cilist io___8 = { 0, 6, 0, 0, 0 };
    static cilist io___11 = { 0, 10, 1, fmt_600, 0 };
    static cilist io___14 = { 0, 6, 0, 0, 0 };
    static cilist io___39 = { 0, 6, 0, fmt_1100, 0 };
    static cilist io___40 = { 0, 6, 0, fmt_1200, 0 };
    static cilist io___41 = { 0, 6, 0, fmt_1300, 0 };


/*     NMAX is the size for the array declarations */

/*     The size of the (sub-)array that is actually used is given by */
/*     the number N which is read from the input file. */
/*     The relation N <= NMAX must hold. */




/*     READ INITIAL DATA */

    o__1.oerr = 1;
    o__1.ounit = 10;
    o__1.ofnmlen = 13;
    o__1.ofnm = "TOMCATV.MODEL";
    o__1.orl = 0;
    o__1.osta = "OLD";
    o__1.oacc = 0;
    o__1.ofm = 0;
    o__1.oblnk = 0;
    i__1 = f_open(&o__1);
    if (i__1 != 0) {
	goto L999;
    }
    goto L1;
L999:
    s_wsle(&io___1);
    do_lio(&c__9, &c__1, "FILE \"TOMCATV.MODEL\" DOES NOT EXIST; STOP", (
	    ftnlen)41);
    e_wsle();
    s_stop("", (ftnlen)0);
L1:
    s_rsle(&io___2);
    do_lio(&c__3, &c__1, (char *)&n, (ftnlen)sizeof(integer));
    do_lio(&c__3, &c__1, (char *)&itact, (ftnlen)sizeof(integer));
    do_lio(&c__5, &c__1, (char *)&dlo, (ftnlen)sizeof(doublereal));
    do_lio(&c__5, &c__1, (char *)&dhi, (ftnlen)sizeof(doublereal));
    do_lio(&c__5, &c__1, (char *)&alpha, (ftnlen)sizeof(doublereal));
    e_rsle();
    if (itact > 1000 || n > 513) {
	s_wsle(&io___8);
	do_lio(&c__9, &c__1, "Please recompile:  This version is lacking Sto\
rage", (ftnlen)50);
	e_wsle();
	s_stop("", (ftnlen)0);
    }

/*     READ START CONFIGURATION */

    i__1 = n;
    for (j = 1; j <= i__1; ++j) {
	i__2 = n;
	for (i__ = 1; i__ <= i__2; ++i__) {
	    i__3 = s_rsfe(&io___11);
	    if (i__3 != 0) {
		goto L990;
	    }
	    i__3 = do_fio(&c__1, (char *)&x[i__ + j * 513 - 514], (ftnlen)
		    sizeof(doublereal));
	    if (i__3 != 0) {
		goto L990;
	    }
	    i__3 = do_fio(&c__1, (char *)&y[i__ + j * 513 - 514], (ftnlen)
		    sizeof(doublereal));
	    if (i__3 != 0) {
		goto L990;
	    }
	    i__3 = e_rsfe();
	    if (i__3 != 0) {
		goto L990;
	    }
/* L10: */
	}
    }
    goto L2;
L990:
    s_wsle(&io___14);
    do_lio(&c__9, &c__1, "\"TOMCATV.MODEL INCOSISTANT; STOP", (ftnlen)32);
    e_wsle();
    s_stop("", (ftnlen)0);
L2:

    /*** VERSABENCH START ***/
/*     START ITERATION LOOP 140 */

/* FLIP140 */
    i__2 = itact;
    for (iter = 1; iter <= i__2; ++iter) {

/*     Residuals of ITER iteration */

	rxm[iter - 1] = 0.;
	rym[iter - 1] = 0.;

	i__1 = n - 1;
	for (j = 2; j <= i__1; ++j) {

	    i__3 = n - 1;
	    for (i__ = 2; i__ <= i__3; ++i__) {
		xx = x[i__ + 1 + j * 513 - 514] - x[i__ - 1 + j * 513 - 514];
		yx = y[i__ + 1 + j * 513 - 514] - y[i__ - 1 + j * 513 - 514];
		xy = x[i__ + (j + 1) * 513 - 514] - x[i__ + (j - 1) * 513 - 
			514];
		yy = y[i__ + (j + 1) * 513 - 514] - y[i__ + (j - 1) * 513 - 
			514];
		a = (xy * xy + yy * yy) * .25;
		b = (xx * xx + yx * yx) * .25;
		c__ = (xx * xy + yx * yy) * .125;
		aa[i__ + j * 513 - 514] = -b;
		dd[i__ + j * 513 - 514] = b + b + a * 2.0408163265306123;
		pxx = x[i__ + 1 + j * 513 - 514] - x[i__ + j * 513 - 514] * 
			2. + x[i__ - 1 + j * 513 - 514];
		qxx = y[i__ + 1 + j * 513 - 514] - y[i__ + j * 513 - 514] * 
			2. + y[i__ - 1 + j * 513 - 514];
		pyy = x[i__ + (j + 1) * 513 - 514] - x[i__ + j * 513 - 514] * 
			2. + x[i__ + (j - 1) * 513 - 514];
		qyy = y[i__ + (j + 1) * 513 - 514] - y[i__ + j * 513 - 514] * 
			2. + y[i__ + (j - 1) * 513 - 514];
		pxy = x[i__ + 1 + (j + 1) * 513 - 514] - x[i__ + 1 + (j - 1) *
			 513 - 514] - x[i__ - 1 + (j + 1) * 513 - 514] + x[
			i__ - 1 + (j - 1) * 513 - 514];
		qxy = y[i__ + 1 + (j + 1) * 513 - 514] - y[i__ + 1 + (j - 1) *
			 513 - 514] - y[i__ - 1 + (j + 1) * 513 - 514] + y[
			i__ - 1 + (j - 1) * 513 - 514];

/*     CALCULATE RESIDUALS ( EQUAL TO RIGHT HAND SIDES OF EQUS.) */

		rx[i__ + j * 513 - 514] = a * pxx + b * pyy - c__ * pxy;
		ry[i__ + j * 513 - 514] = a * qxx + b * qyy - c__ * qxy;

/* L50: */
	    }
/* L60: */
	}

/*     DETERMINE MAXIMUM VALUES RXM, RYM OF RESIDUALS */

	i__1 = n - 1;
	for (j = 2; j <= i__1; ++j) {
	    i__3 = n - 1;
	    for (i__ = 2; i__ <= i__3; ++i__) {
/* Computing MAX */
		d__2 = rxm[iter - 1], d__3 = (d__1 = rx[i__ + j * 513 - 514], 
			abs(d__1));
		rxm[iter - 1] = max(d__2,d__3);
/* Computing MAX */
		d__2 = rym[iter - 1], d__3 = (d__1 = ry[i__ + j * 513 - 514], 
			abs(d__1));
		rym[iter - 1] = max(d__2,d__3);
/* L80: */
	    }
	}

/*     SOLVE TRIDIAGONAL SYSTEMS (AA,DD,AA) IN PARALLEL, LU DECOMPOSITION */

	i__3 = n - 1;
	for (i__ = 2; i__ <= i__3; ++i__) {
	    d__[i__ + 512] = 1. / dd[i__ + 512];
/* L90: */
	}
	i__3 = n - 1;
	for (j = 3; j <= i__3; ++j) {
	    i__1 = n - 1;
	    for (i__ = 2; i__ <= i__1; ++i__) {
		r__ = aa[i__ + j * 513 - 514] * d__[i__ + (j - 1) * 513 - 514]
			;
		d__[i__ + j * 513 - 514] = 1. / (dd[i__ + j * 513 - 514] - aa[
			i__ + (j - 1) * 513 - 514] * r__);
		rx[i__ + j * 513 - 514] -= rx[i__ + (j - 1) * 513 - 514] * 
			r__;
		ry[i__ + j * 513 - 514] -= ry[i__ + (j - 1) * 513 - 514] * 
			r__;
/* L100: */
	    }
	}
	i__1 = n - 1;
	for (i__ = 2; i__ <= i__1; ++i__) {
	    rx[i__ + (n - 1) * 513 - 514] *= d__[i__ + (n - 1) * 513 - 514];
	    ry[i__ + (n - 1) * 513 - 514] *= d__[i__ + (n - 1) * 513 - 514];
/* L110: */
	}
	for (j = n - 2; j >= 2; --j) {
	    i__1 = n - 1;
	    for (i__ = 2; i__ <= i__1; ++i__) {
		rx[i__ + j * 513 - 514] = (rx[i__ + j * 513 - 514] - aa[i__ + 
			j * 513 - 514] * rx[i__ + (j + 1) * 513 - 514]) * d__[
			i__ + j * 513 - 514];
		ry[i__ + j * 513 - 514] = (ry[i__ + j * 513 - 514] - aa[i__ + 
			j * 513 - 514] * ry[i__ + (j + 1) * 513 - 514]) * d__[
			i__ + j * 513 - 514];
/* L120: */
	    }
	}

/*     ADD CORRECTIONS OF ITER ITERATION */

	i__1 = n - 1;
	for (j = 2; j <= i__1; ++j) {
	    i__3 = n - 1;
	    for (i__ = 2; i__ <= i__3; ++i__) {
		x[i__ + j * 513 - 514] += rx[i__ + j * 513 - 514];
		y[i__ + j * 513 - 514] += ry[i__ + j * 513 - 514];
/* L130: */
	    }
	}

	abx = (d__1 = rxm[iter - 1], abs(d__1));
	aby = (d__1 = rym[iter - 1], abs(d__1));
	if (abx <= 5e-9 && aby <= 5e-9) {
	    goto L150;
	}
/* L140: */
    }

/*     END OF ITERATION LOOP 140 */
    /*** VERSABENCH END ***/
L150:

/*     OUTPUT OF CONVERGENCE BEHAVIOR */

    s_wsfe(&io___39);
    e_wsfe();
    s_wsfe(&io___40);
    e_wsfe();
    i__2 = iter - 1;
    for (i__ = 1; i__ <= i__2; ++i__) {
	s_wsfe(&io___41);
	do_fio(&c__1, (char *)&i__, (ftnlen)sizeof(integer));
	do_fio(&c__1, (char *)&rxm[i__ - 1], (ftnlen)sizeof(doublereal));
	do_fio(&c__1, (char *)&rym[i__ - 1], (ftnlen)sizeof(doublereal));
	e_wsfe();
/* L160: */
    }


    s_stop("", (ftnlen)0);
} /* MAIN__ */

